<?php
require_once 'docente.php';
require_once 'qualificacao.php';
require_once 'qualis.php';
require_once 'regras.php';
require_once 'veiculo.php';
require_once 'publicacao.php';
require_once 'periodico.php';
require_once 'conferencia.php';

class Leitor {
	private $docentes;
	private $regras;
	private $veiculos;
	private $publicp;
	private $publicc;
	private $qualisArq;
	private $listregras;

	function __constructor() {
		$docentes = array();
		$regras = null;
		$veiculos = array();
		$publicp = array();
		$publicc = array();
		$qualisArq = array();
		$listaregras = array();
	}

	// Método para ler o arquivo de docentes
	public function LeDocentes ($arq) {
		$scanner = fopen($arq, "r");
		$contents = fread($scanner, filesize ($arq));
		fclose($scanner);
		$contents_list = explode("\n", $contents);
		if (count ($contents_list) <= 1) {
			return null;
		}
		for ($i = 1; $i < count($contents_list); $i++) {
			$separated_contents_lists = explode(";", $contents_list[$i]);
			if (!(count($separated_contents_lists) > 1)) {
				continue;
			}
			$cod = trim($separated_contents_lists[0]);
			$nome = trim($separated_contents_lists[1]);
			$dataNasc = explode("/", trim($separated_contents_lists[2]));
			$dataNasc = new DateTime($dataNasc[2] . "-" . $dataNasc[1] . "-" . $dataNasc[0]);
			$dataIngresso = explode("/", trim($separated_contents_lists[3]));
			$dataIngresso = new DateTime($dataIngresso[2] . "-" . $dataIngresso[1] . "-" . $dataIngresso[0]);
			$coordenador = false;
			if (count($separated_contents_lists) >= 5) {
				$coordenador = trim($separated_contents_lists[4]) == "X";
			}
			$this->docentes[] = new Docente ($cod, $nome, $dataNasc, $dataIngresso, $coordenador);
		}
		return $this->docentes;
	}

	public function LeRegras ($arq) {
		$scanner = fopen ($arq, "r");
		$contents = fread ($scanner, filesize ($arq));
		fclose ($scanner);
		$contents_list = explode ("\n", $contents);
		if (count ($contents_list) <= 1) {
			return null;
		}
		for ($i = 1; $i < count($contents_list); $i++) {
			$separated_contents_lists = explode(";", $contents_list[$i]);
			if (!(count($separated_contents_lists) > 1)) {
				continue;
			}
			// Datas são lidas como strings.
			$datIni = explode("/", trim($separated_contents_lists[0]));
			$datIni = new DateTime($datIni[2] . "-" . $datIni[1] . "-" . $datIni[0]);
			$datFim = explode("/", trim($separated_contents_lists[1]));
			$datFim = new DateTime($datFim[2] . "-" . $datFim[1] . "-" . $datFim[0]);
			$qualislist = explode(",", trim($separated_contents_lists[2]));
			$pontos = explode(",", trim($separated_contents_lists[3]));
			$fatorMult = trim($separated_contents_lists[4]);
			$qntAnos = trim($separated_contents_lists[5]);
			$pontMin = trim($separated_contents_lists[6]);

			$i = -1;
			$q = 0;
			$qualistotal = ['A1', 'A2', 'B1', 'B2', 'B3', 'B4', 'B5', 'C'];
			$qualis = array();
			foreach ($qualistotal as $key) {
				if ($key == trim($qualislist[$q])) {
					$q++;
					$i++;
				}
				$qualis[] = new Qualis($key, intval(trim($pontos[$i])));
			}
			$this->listregras[] = new Regras($qualis, $fatorMult, $datIni, $datFim, $qntAnos, $pontMin);
		}
	}

	// Método para ler o arquivo de veículos
	public function LeVeiculos($arq, $qualis, $ano) {
		$this->veiculos = array();
		$scanner = fopen ($arq, "r");
		$contents = fread ($scanner, filesize ($arq));
		fclose ($scanner);
		$contents_list = explode ("\n", $contents);
		if (count ($contents_list) <= 1) {
			return null;
		}
		for ($i = 1; $i < count($contents_list); $i++) {
			$separated_contents_lists = explode(";", $contents_list[$i]);
			if (!(count($separated_contents_lists) > 1)) {
				continue;
			}
			$sigla = trim($separated_contents_lists[0]);
			$nome = trim($separated_contents_lists[1]);
			$tipo = trim($separated_contents_lists[2]);
			$result = str_replace(',', '.', trim($separated_contents_lists[3]));
			$fator = floatval($result);
			$issn = trim($separated_contents_lists[4]);

			$this->veiculos[] = new Veiculo($sigla, $nome, $tipo, $fator, $issn, $qualis, $ano, $this->regras->getQualis());
		}
	}

	public function LeQualis($arq, $qualislist) {
		$scanner = fopen ($arq, "r");
		$contents = fread ($scanner, filesize ($arq));
		fclose ($scanner);
		$contents_list = explode ("\n", $contents);
		if (count ($contents_list) <= 1) {
			return null;
		}
		for ($i = 1; $i < count($contents_list); $i++) {
			$separated_contents_lists = explode(";", $contents_list[$i]);
			if (!(count($separated_contents_lists) > 1)) {
				continue;
			}
			$ano = trim($separated_contents_lists[0]);
			$sigla = trim($separated_contents_lists[1]);
			$qualisname = trim($separated_contents_lists[2]);
			$aux = 0;
			foreach ($qualislist as $key) {
				if ($qualisname == $key->getNome()) {
					$aux = 1;
					break;
				}
			}

			$this->qualisArq[] = $ano . ";" . $sigla . ";" . $qualisname . "\n";
		}
	}

	// Método para ler o arquivo de qualificações
	public function getQualificacao($veiculo, $qualistotal, $ano, $qualislist) {
		$lista = array();
		$qualis = null;
		$veiculoin = "";
		$qualisname = "";
		for ($k = 0; $k < count($qualistotal); $k++) {
			$s = "";
			$cont = 0;
			for ($z = 0; $z < strlen($qualistotal[$k]); $z++) {
				if ($qualistotal[$k][$z] == ";") {
					$s = trim($s);
					if ($cont == 0) {
						$ano = intval($s);
						$cont++;
					} else if ($cont == 1) {
						$veiculoin = $s;
						$cont++;
					}
					$s = "";
				} else
					$s = $s . $qualistotal[$k][$z];
			}
			$qualisname = trim($s);
			if ($veiculoin == $veiculo->getSigla()) {
				for ($i = 0; $i < count($qualislist); $i++) {
					if ($qualisname == $qualislist[$i]->getNome()) {
						$qualis = $qualislist[$i];
						break;
					}
				}
				$lista[] = new Qualificacao($ano, $qualis);
			}

		}
		return $lista;
	}

	// Método para ler o arquivo de publicações
	public function LePublicacoes($arq) {
		$this->publicp = array();
		$this->publicc = array();

		$scanner = fopen ($arq, "r");
		$contents = fread ($scanner, filesize ($arq));
		fclose ($scanner);
		$contents_list = explode ("\n", $contents);
		if (count ($contents_list) <= 1) {
			return null;
		}
		for ($i = 1; $i < count($contents_list); $i++) {
			$separated_contents_lists = explode(";", $contents_list[$i]);
			if (!(count($separated_contents_lists) > 1)) {
				continue;
			}
			$anos = trim($separated_contents_lists[0]);
			$veiculo = trim($separated_contents_lists[1]);
			$titulo = trim($separated_contents_lists[2]);
			$autor = trim($separated_contents_lists[3]);
			$numero = intval(trim($separated_contents_lists[4]));
			$listad = array();
			$s = "";

			for ($k = 0; $k < strlen($autor); $k++) {
				if ($autor[$k] == ",") {
					$cod = trim($s);
					$aux = 0;
					while ($cod != $this->docentes[$aux]->getCod()) {
						if ($aux >= count($this->docentes)) {
							break;
						}
						$aux++;
					}
					$listad[] = ($this->docentes[$aux]);
					$s = "";
				} else {
					$s = $s . $autor[$k];
				}
			}
			$cod = trim($s);
			$aux = 0;
			while ($cod != $this->docentes[$aux]->getCod()) {
				if ($aux >= count($this->docentes)) {
					break;
				}
				$aux++;
			}
			$listad[] = $this->docentes[$aux];
			for ($k = 0; $k < count($this->veiculos); $k++) {
				if ($veiculo == $this->veiculos[$k]->getSigla()) {
					if ($this->veiculos[$k]->getTipo() == "P") {
						$volume = intval(trim($separated_contents_lists[5]));
						$pagInicial = intval(trim($separated_contents_lists[7]));
						$pgFinal = intval(trim($separated_contents_lists[8]));
						$ano = intval($anos);
						$this->publicp[] = new Periodico($ano, $veiculo, $titulo, $listad, $numero, $volume, $pagInicial, $pgFinal,
								$this->veiculos);
					} else {
						$local = intval(trim($separated_contents_lists[6]));
						$pagInicial = intval(trim($separated_contents_lists[7]));
						$pgFinal = intval(trim($separated_contents_lists[8]));
						$ano = intval($anos);
						$this->publicc[] = new Conferencia($ano, $veiculo, $titulo, $listad, $numero, $local, $pagInicial,
								$pgFinal, $this->veiculos);
					}
					break;
				}
			}
		}
	}


	// getters
	public function getVeiculos() {
		return $this->veiculos;
	}

	public function getDocentes() {
		return $this->docentes;
	}

	public function getRegras($ano) {
		$hoje = new DateTime($ano . "-01-01");
		foreach ($this->listregras as $regra) {
			if ($hoje->diff($regra->getDatIni())->invert == 1 | $hoje->diff($regra->getDatIni())->days == 0) {
				if ($hoje->diff($regra->getDatFim())->invert == 0) {
					$this->regras = $regra;
					return $this->regras;
				}
			}
		}
		return null;
	}

	public function getPublicp() {
		return $this->publicp;
	}

	public function getPublicc() {
		return $this->publicc;
	}

	public function getQualislist() {
		return $this->qualisArq;
	}
}
?>
