<?php
require_once 'leitor.php';
require_once 'docente.php';
require_once 'qualificacao.php';
require_once 'qualis.php';
require_once 'regras.php';
require_once 'veiculo.php';
require_once 'publicacao.php';
require_once 'periodico.php';
require_once 'conferencia.php';

/* Define para Português(Brasil) ) */
setlocale (LC_ALL, 'pt_BR');

$arq = new Leitor ();
$arqVeiculos = "";
$arqDocentes = "";
$arqPublic = "";
$arqQualis = "";
$arqRegras = "";
$ano = 0;

for ($i = 0; $i < count ($argv); $i++) {
	if ($argv[$i] == "-d")
		$arqDocentes = $argv[$i + 1];
	elseif ($argv[$i] == "-v")
		$arqVeiculos = $argv[$i + 1];
	elseif ($argv[$i] == "-q")
		$arqQualis = $argv[$i + 1];
	elseif ($argv[$i] == "-a")
		$ano = intval ($argv[$i + 1]);
	elseif ($argv[$i] == "-p")
		$arqPublic = $argv[$i + 1];
	elseif ($argv[$i] == "-r")
		$arqRegras = $argv[$i + 1];
}

$auxNotNull = false; // auxiliar para verificar se falta algum arquivo

$arq->LeRegras($arqRegras); // faz as leituras em ordem de dependencia
$regras = $arq->getRegras($ano);
if ($regras != null) {
	$arq->LeDocentes($arqDocentes);
	$docentes = $arq->getDocentes();
	if ($docentes != null) {
		$arq->LeQualis($arqQualis, $regras->getQualis());
		$qualislist = $arq->getQualislist();
		if ($qualislist != null) {
			$arq->LeVeiculos($arqVeiculos, $qualislist, $ano);
			$veiculos = $arq->getVeiculos();
			if ($veiculos != null) {
				$arq->LePublicacoes($arqPublic);
				$publicp = $arq->getPublicp();
				$publicc = $arq->getPublicc();
				if ($publicc != null || $publicp != null) {
					$auxNotNull = true;
				}
			}
		}
	}
}

if ($auxNotNull) {
	// ordena lista de docentes pelo nome
	usort($docentes, "cmp");

	// calcula a pontuação de cada docente
	for ($i = 0; $i < count($docentes); $i++) {
		$docentes[$i]->calculaPontuacao($publicp, $publicc, $veiculos, $regras, $ano);
	}

	// cria a lista unica de publicações para a saída 2
	$publicacoes = array();
	for ($i = 0; $i < count($publicc); $i++) {
		$publicacoes[] = $publicc[$i];
	}
	for ($i = 0; $i < count($publicp); $i++) {
		$publicacoes[] = $publicp[$i];
	}

	// ordena a lista de publicações com as seguintes prioridades:
	// 1) Qualis (decrescente);
	// 2) Ano (decrescente);
	// 3) Sigla do veículo (crescente);
	// 4) Título da publicação (crescente);
	usort($publicacoes, "compare");

	// geração recredenciamento.csv
	$arqSaida = fopen ("1-recredenciamento.csv", "w");
	fwrite ($arqSaida, "Docente;Pontuação;Recredenciado?\n");
	for ($i = 0; $i < count ($docentes); $i++) {
		fwrite ($arqSaida, $docentes[$i]->toString() .
				$docentes[$i]->ehRecredenciado($regras, $ano) . "\n");
	}
	fclose ($arqSaida);

	// geração do publicacoes.csv
	$arqSaida = fopen ("2-publicacoes.csv", "w");
	fwrite ($arqSaida, "Ano;Sigla Veículo;Veículo;Qualis;Fator de ");
	fwrite ($arqSaida, "Impacto;Título;Docentes\n");
	for ($i = 0; $i < count ($publicacoes); $i++) {
		fwrite ($arqSaida, $publicacoes[$i]->toString() . "\n");
	}
	fclose ($arqSaida);
}

function cmp($a, $b) {
  return strcmp($a->getNome(), $b->getNome());
}

function compare($a, $b) {

	$i = strcmp($a->getVeiculo()->getQualificacao($a->getAno())->getQualis()->getNome(),
							$b->getVeiculo()->getQualificacao($b->getAno())->getQualis()->getNome());

	if ($i != 0) return $i;

	$i = $b->getAno() - $a->getAno();

	if ($i != 0) return $i;

	$i = strcmp($a->getVeiculo()->getSigla(), $b->getVeiculo()->getSigla());

	if ($i != 0) return $i;

	return strcmp($a->getTitulo(), $b->getTitulo());
}
?>
