<?php
class Publicacao {
  private $ano;
  private $veiculo; // Veiculo object
  private $titulo;
  private $autores; // Docente list
  private $pagInicial;
  private $pgFinal;
  private $numero;

  function __construct($ano, $sigla, $titulo, $autores, $pagInicial, $pgFinal, $numero, $veiculos) {
    $this->ano = $ano;
    $this->titulo = $titulo;
    $this->pagInicial = $pagInicial;
    $this->pgFinal = $pgFinal;
    $this->numero = $numero;
    $this->autores = $autores;

    //define o veículo a partir da sigla dele
    foreach ($veiculos as $veiculo) {
      if ($veiculo->getSigla() == $sigla) {
        $this->veiculo = $veiculo;
        break;
      }
    }
  }

	//retorna se o docente é ou não autor da Publicacao
  public function ehAutor($cod) {
  	foreach ($this->autores as $autor) {
  		if ($cod == $autor->getCod())
  			return true;
  	}
  	return false;
  }


	public function toString() {
		$autores = "";
    $result = number_format($this->veiculo->getFatorImpacto(), 3, ',', '');
    $aux = 0;
		foreach ($this->autores as $aut) {
      $autores = $autores . $aut->getNome();
			if ($aux < (count($this->autores) - 1)) {
				$autores = $autores . ",";
			}
      $aux++;
		}
		return $this->ano . ";" . $this->veiculo->getSigla() . ";"	. $this->veiculo->getNome() .
				";" . $this->veiculo->getQualificacao($this->ano)->getQualis()->getNome() .
				";" . $result . ";" . $this->titulo . ";" . $autores;
	}

  //getters
  public function getAutores(){
    return $this->autores;
  }

  public function getVeiculo() {
    return $this->veiculo;
  }

  public function getAno() {
    return $this->ano;
  }

  public function getTitulo() {
    return $this->titulo;
  }
}
?>
