<?php
require_once 'leitor.php';

class Veiculo {
  private $sigla;
  private $nome;
  private $tipo;
  private $fatorImpacto;
  private $ISSN;
  private $qualificacao;

  function __construct($sigla, $nome, $tipo, $fatorImpacto, $iSSN, $qualistotal, $ano, $qualislist) {
    $this->sigla = $sigla;
    $this->nome = $nome;
    $this->tipo = $tipo;
    $this->fatorImpacto = $fatorImpacto;
    $this->ISSN = $iSSN;
    $arq = new Leitor();
    $this->qualificacao = $arq->getQualificacao($this, $qualistotal, $ano, $qualislist);
  }

  public function getQualificacao($ano){
    $qualificacao = null;
    foreach ($this->qualificacao as $ql) {
      if ($ql->getAno() <= $ano)
        $qualificacao = $ql;
    }
    return $qualificacao;
  }

  // getters

  public function getSigla() {
    return $this->sigla;
  }

  public function getNome() {
    return $this->nome;
  }

  public function getTipo() {
    return $this->tipo;
  }

  public function getFatorImpacto() {
    return $this->fatorImpacto;
  }

  public function getISSN() {
    return $this->ISSN;
  }
}

?>
